        ORG 60000
        LD DE,0x1800    ;D = numlin, E = linini
        LD HL,0xffe0    ;H=0xff, flag de interface Kempston conectado.
                        ;L=%11100000, mscara de bits (tanto o teclado como
                        ;             Kempston usam apenas 5 bits).
main1:  LD C,0          ;opt = 0
main2:  CALL linatt     ;Destaca linha
;O lao wait1 espera tecla/joystick estarem livres. 
wait1:  HALT            ;Pausa de aproximadamente 1/60s.
        CALL rdkey		;L teclado, 
		JR NZ,wait1		;Se estiver pressionado, salta para trs.
		CALL rdjoy		;L joystick Kempston
		JR NC,wait2		;Se Kempston desconectado, salta para frente.
		JR NZ,wait1     ;Se Kempston acionado, salta para trs.
;O lao wait2 espera tecla/joystick ser acionado.
wait2:  HALT            ;Pausa de aproximadamente 1/60s.
        CALL rdkey      ;L teclado.
		JR NZ,main3     ;Se tecla pressionada, salta para frente.
        CALL rdjoy      ;L joystick.
        JR NC,wait2     ;Se Kempston desconectado, salta para trs.
        JR Z,wait2      ;Se joystick no acionado, salta para tras.
        DEC A           ;Restaura resultado da leitura do joystick.
        AND %00010000   ;Foi acionado boto do joystick? (bit 4=0)
        JR Z,linatt     ;  sim, retorna ao BASIC, desmarcando linha
        JR main4
main3:  RRCA            ; tecla encerrar? (bit 0=1)
        JR C,linatt     ;  sim, retorna ao BASIC. desmarcando linha.
main4:  CALL linatt     ;Desmarca linha
        INC C           ;  seno opt = opt+1
        LD A,D          ;opt=numlin?
        CP C
        JR Z,main1      ;  sim, opt = 0
        JR main2        ;  seno prossegue na prxima linha.
;Sub-rotina "linatt".
;Inverte FLASH e BRIGHT da linha linini+opt
linatt: PUSH DE         ;Preserva numlin/linini.
        PUSH HL         ;Preserva flag e mscara.
        LD A,E          ;Contador=linini+opt+1
        ADD C
        INC A
        LD B,A          ;B ser o contador.
        LD HL,22496     ;incio de atribut - 32
        LD DE,32        ;32 colunas por linha
loop1:  ADD HL,DE       ;HL=22496+linini*32
        DJNZ loop1      ;Repete o lao at B=0.
        LD B,E          ;Contador=32
loop2:  LD A,%11000000  ;FLASH e BRIGHT sero invertidos
        XOR (HL)        ;por operador XOR.
        LD (HL),A        
        INC HL          ;Prxima posio na rea de atributos.
        DJNZ loop2      ;Repete lao. Nota: sai com B=0
        POP HL          ;Recupera flag e mscara.
        POP DE          ;Recupera numlim/linini.
        RET
;Sub-rotina "rdjoy" (read joystick)
;Verifica se flag de Kempston conectado est ativo, seno retorna.
;Faz a leitura da interface Kempston, verifica se est conectado e atualiza o 
;respectivo flag. Se estiver conectado, verifica se acionou-se algum controle
;do joystick.

rdjoy:  XOR A			;A=0.
        OR H			;Verifica se H  zero (flag Kempston desconectado).
		RET Z           ;Se era 0, sai da rotina com CARRY=0.
        IN A,(31)       ;Leitura do joystick Kempston.
        AND L           ;And %11100000.
        JR Z,rdjoy1		;Se bits 5-7 eram 0, salta (Kempston conectado).
        INC H           ;Seno H  incrementado para 0 e
        JR rdjoy        ;salta para o incio da sub-rotina.
rdjoy1: IN A,(31)       ;Leitura do joystick Kempston.
        CPL             ;Inverte os valores dos bits (bits acionados do joystick
                        ;passam a ser 0).
        JR rdjoy2       ;Continua adiante.
;Sub-rotina "rdkey" (read keyboard).
;Faz leitura do teclado, retorna com flag ZERO=1 se nenhuma tecla pressionada.
;L deve conter %11100000 (mscara para bits 5 a 7).
rdkey:  XOR A           ;A=0.
        IN A,(254)      ;Leitura do teclado.
rdjoy2: OR L            ;Se nenhum tecla/controle do joystick acionado, A=0xFF.
        INC A			;Se A tinha 0xFF, fica 0x00 e levanta flag ZERO.
        SCF             ;CARRY=1, sinaliza Kempston conectado.
        RET

