attr_p: EQU 23693       ;Varivel do sistema: atributos permanentes
mask_p: EQU 23694       ;Varivel do sistema: cores transparentes
prints: EQU 8252        ;Rotina da ROM: PRINT STRING
        ORG 20480
;=============================================================================
; Inicia a preparao da tela
; Lembrar que o tero inferior da tela contm o cdigo de mquina, portanto 
;  no deve ser modificado
;
        LD A,$FF        ;PRINT no alterar os atributos
        LD (mask_p),A
        LD A,(attr_p)
        AND %00111000   ;Pega o PAPER
        CP  %00100000   ;Se PAPER > 3
        JR NC,ink0      ; seno INK=0
        OR %00000111    ; ento INK=7
ink0:   LD HL,22528     ;Preenche o tero superior da tela com atributo A
        LD BC,512       ;HL=end. inicial atributos e BC=512 bytes
        LD E,A
next01: LD (HL),E
        INC HL
        DEC BC
        LD A,B
        OR C
        JR NZ,next01
        LD A,E          ;Torna INK=PAPER
        AND %00111000   ;A=PAPER
        SRL E
        SRL E
        SRL E           ;E=INK
        OR E
        LD E,A
        LD BC,256       ;Preenche o tero inferior da tela com atributo E
next02: LD (HL),E       ;Obs: HL j contm o endereo apropriado
        INC HL
        DEC BC
        LD A,B
        OR C
        JR NZ,next02                
        CALL cls0       ;Apaga tero superior
; Imprime mensagem com instrues, etc. 
;
        LD A,2          ;Abre canal 2, a partir de agora PRINT vai sempre
        CALL 5633       ; imprimir na tela principal (no a linha de edio)
        LD DE,msg1
        LD BC,msg2-msg1
        CALL prints
; Lao principal do programa
        LD HL,pokes
next03: PUSH HL         ;Preserva HL
        CALL cls1       ;Limpa tero central
        LD DE,msg2      ;Imprime mensagem 2
        LD BC,msg3-msg2
        CALL prints
        POP HL
;  Imprime opes
        LD A,31
        CP (HL)         ;Se caractere < " "?
        RET NC          ;  ento volta ao BASIC
        CALL pr_opt     ;Imprime opo 0 do menu,
        LD A,13         ; pula linha
        RST 16
        CALL pr_opt     ; e imprime opo 1
        PUSH HL
        LD DE,$020A     ;D=2 e E=10
        CALL menu_s     ;Seleciona item do menu
        POP HL
        XOR A           ;Se Opo = 0 -> flag Z
        CP C
next04: EX AF,AF'       ;Salva flag Z
        LD E,(HL)       ;DE = endereo para POKE
        INC HL
        LD D,(HL)
        INC HL
        LD A,%11000000  ;Se DE < 16384
        AND D
        JR Z,next03     ;  ento para prximo POKE
        EX AF,AF'       ;flag Z -> ento no efetua POKE
        JR Z,nopoke     ;          
        LD A,(HL)       ;          seno efetua POKE
        LD (DE),A 
nopoke: INC HL
        JR next04       ;Para prximo endereo do POKE
;=============================================================================
; Subrotina que limpa um dos teros da tela
; Possui duas entradas, cls0 para o tero superior e
;   cls1 para o tero central
;
cls0:   LD HL,16384     ;Define tero superior da tela
        JR cls0a        
cls1:   LD HL,18432     ;Define tero central da tela
cls0a:  LD BC,2048      ;Cada tero tem 2 kb
        LD E,C          ;E=0
cnext:  LD (HL),E       ;Apaga o tero da tela
        INC HL
        DEC BC
        LD A,C
        OR B
        JR NZ,cnext
        RET
;=============================================================================
; Rotina que imprime as opes 0 e 1 do menu
;
pr_opt: LD A,(HL)       ;HL=endereo do string
        AND 01111111b   ;Zera bit 7
        RST 16          ;Imprime A
        BIT 7,(HL)      ;Bit 7 do caractere=1?
        INC HL          ;Prximo endereo
        RET NZ          ; ento encerrar subrotina
        JR pr_opt       ; seno prossegue prx. caractere
;=============================================================================
; Mensagem inicial do programa
;
msg1:   DEFB 20,1               ;INVERSE 1;
        DEFB 22,0,16-(m1b-m1a)/2   ;AT 0,x; - centraliza nome do jogo
m1a:    DEFM " Bionic Commando "
m1b:    DEFB 20,0               ;INVERSE 0;
        DEFB 22,2,0             ;AT 2,0;
        DEFM "Tecle:"
        DEFB 13                 ;ENTER
        DEFM "0 1 Q A P Caps-Shift Space Enter"
        DEFM "ou botao de tiro para aceitar."
        DEFB 13,13              ;ENTER
        DEFM "Outras  teclas  ou  alavanca  do"
        DEFM "joystick muda selecao."
msg2:   DEFB 22,14,0            ;AT 14,0;
        DEFB 20,1               ;INVERSE 1;
        DEFM "Game poke by"
        DEFB 6,6                ;preenche linha
        DEFM "   reikainosuke-tk@yahoo.com.br "
        DEFB 20,0               ;INVERSE 0;
        DEFB 22,10,0            ;AT 10,0; (1a. opo)
msg3:   DEFB $FF
;=============================================================================
menu_s:  LD HL,0xffe0    ;H=0xff, flag de interface Kempston conectado.
                        ;L=%11100000, mscara de bits (tanto o teclado como
                        ;             Kempston usam apenas 5 bits).
main1:  LD C,0          ;opt = 0
main2:  CALL linatt     ;Destaca linha
;O lao wait1 espera tecla/joystick estarem livres. 
wait1:  HALT            ;Pausa de aproximadamente 1/60s.
        CALL rdkey		;L teclado, 
		JR NZ,wait1		;Se estiver pressionado, salta para trs.
		CALL rdjoy		;L joystick Kempston
		JR NC,wait2		;Se Kempston desconectado, salta para frente.
		JR NZ,wait1     ;Se Kempston acionado, salta para trs.
;O lao wait2 espera tecla/joystick ser acionado.
wait2:  HALT            ;Pausa de aproximadamente 1/60s.
        CALL rdkey      ;L teclado.
		JR NZ,main3     ;Se tecla pressionada, salta para frente.
        CALL rdjoy      ;L joystick.
        JR NC,wait2     ;Se Kempston desconectado, salta para trs.
        JR Z,wait2      ;Se joystick no acionado, salta para trs.
        DEC A           ;Restaura resultado da leitura do joystick.
        AND %00010000   ;Foi acionado boto do joystick? (bit 4=0)
        JR Z,linatt     ;  sim, retorna ao BASIC, desmarcando linha
        JR main4
main3:  RRCA            ; tecla encerrar? (bit 0=1)
        JR C,linatt     ;  sim, retorna ao BASIC desmarcando linha,
main4:  CALL linatt     ;Desmarca linha,
        INC C           ;opt = opt+1, prxima opo.
        LD A,D          ;opt=numlin?
        CP C
        JR Z,main1      ;  sim, opt = 0,
        JR main2        ;  seno prossegue na prxima linha.
;Sub-rotina "linatt".
;Inverte FLASH e BRIGHT da linha linini+opt
linatt: PUSH DE         ;Preserva numlin/linini.
        PUSH HL         ;Preserva flag e mscara.
        LD A,E          ;Contador=linini+opt+1
        ADD C
        INC A
        LD B,A          ;B ser o contador.
        LD HL,22496     ;incio de atribut - 32
        LD DE,32        ;32 colunas por linha
loop1:  ADD HL,DE       ;HL=22496+linini*32
        DJNZ loop1      ;Repete o lao at B=0.
        LD B,E          ;Contador=32
loop2:  LD A,%11000000  ;FLASH e BRIGHT sero invertidos
        XOR (HL)        ;por operador XOR.
        LD (HL),A        
        INC HL          ;Prxima posio na rea de atributos.
        DJNZ loop2      ;Repete lao. Nota: sai com B=0
        POP HL          ;Recupera flag e mscara.
        POP DE          ;Recupera numlim/linini.
        RET
;Sub-rotina "rdjoy" (read joystick)
;Verifica se flag de Kempston conectado est ativo, seno retorna.
;Faz a leitura da interface Kempston, verifica se est conectado e atualiza o 
;respectivo flag. Se estiver conectado, verifica se acionou-se algum controle
;do joystick.

rdjoy:  XOR A			;A=0.
        OR H			;Verifica se H  zero (flag Kempston desconectado).
		RET Z           ;Se era 0, sai da rotina com CARRY=0.
        IN A,(31)       ;Leitura do joystick Kempston.
        AND L           ;And %11100000.
        JR Z,rdjoy1		;Se bits 5-7 eram 0, salta (Kempston conectado).
        INC H           ;Seno H  incrementado para 0 e
        JR rdjoy        ;salta para o incio da sub-rotina.
rdjoy1: IN A,(31)       ;Leitura do joystick Kempston.
        CPL             ;Inverte os valores dos bits (bits acionados do joystick
                        ;passam a ser 0).
        JR rdjoy2       ;Continua adiante.
;Sub-rotina "rdkey" (read keyboard).
;Faz leitura do teclado, retorna com flag ZERO=1 se nenhuma tecla pressionada.
;L deve conter %11100000 (mscara para bits 5 a 7).
rdkey:  XOR A           ;A=0.
        IN A,(254)      ;Leitura do teclado.
rdjoy2: OR L            ;Se nenhum tecla/controle do joystick acionado, A=0xFF.
        INC A			;Se A tinha 0xFF, fica 0x00 e levanta flag ZERO.
        SCF             ;CARRY=1, sinaliza Kempston conectado.
        RET
;=============================================================================
; Area com dados do poke
; Vidas infinitas
pokes:  DEFM "   Vidas normai", "s"+128
        DEFM "   Vidas infinita", "s"+128
        DEFW 34248
        DEFB 0
        DEFW 34275
        DEFB 0
        DEFW 0
; Imunidade
        DEFM "   Sem imunidad", "e"+128
        DEFM "   Com imunidad", "e"+128
        DEFW 48969
        DEFB 201
        DEFW 0
; Imortalidade 
        DEFM "   Tempo norma", "l"+128
        DEFM "   Tempo infinit", "o"+128
        DEFW 34199
        DEFB 0
        DEFW 0
        DEFB 13                 ;terminador

